#ifndef __ALBUM_CPP_BODY_FILE__
#define __ALBUM_CPP_BODY_FILE__

#include "Album.h"


nodeListR *createNodeR(album sa) {

     nodeListR *p = new nodeListR;      // Creazione nuovo nodo
     p->data = sa;

     p->next = NULL;
	 return p;
}
 

void insertSortedListR(nodeListR*& h, nodeListR* x) {
// Si suppone la lista in ordine alfabetico di codice
// si inserisce un nuovo nodo rispettando tale ordinamento        
// h  passato per reference, per scandire 
// la lista devo quindi usare un puntatore ausiliario.

    nodeListR *curr;
    nodeListR *pred = NULL;

    if (h == NULL) { h = x;
	                 return;
    }
    curr = h ;
    while ((curr!=NULL)&&(strcmp((curr->data).codiceR,(x->data).codiceR)<= 0)){
         pred = curr;
         curr = curr->next ;
    }

    if (pred != NULL) {
	  pred->next = x;
      x->next = curr;
    } else {            // inserimento in testa
	   x->next = h;
	   h = x;
    }
} // end insertSortedListR


nodeListR * CercaCodiceRInListaR(nodeListR * h, char codice[]) { 
// restituisce il puntatore al nodo contenente la prima occorrenza del codice preso come parametro.

	while ((h!=NULL)&&(strcmp(h->data.codiceR,codice)!=0)) 
		 h = h->next;
	return h;

} // end CercaCodiceRInListaR

nodeListR *sottolistaNomeInListaR(nodeListR * h, char s[]) {
	nodeListR *aux = NULL;
	while (h!=NULL) {
		if (strcmp(h->data.nome,s) ==0) 
		  insertSortedListR(aux, createNodeR(h->data));	
		h = h->next;
    }
	return aux;
} // end sottolistaNomeInListaR

nodeListR *sottolistaCodiceAInListaR(nodeListR * h, char s[]) {
	nodeListR *aux = NULL;
	while (h!=NULL) {
		if (strcmp(h->data.codiceA,s) ==0) 
		  insertSortedListR(aux, createNodeR(h->data));	
		h = h->next;
    }
	return aux;
} // end sottolistaCodiceAInListaR
nodeListR *sottolistaAnnoInListaR(nodeListR * h, int a) {
	nodeListR *aux = NULL;
	while (h!=NULL) {
		if (h->data.anno == a) 
		  insertSortedListR(aux, createNodeR(h->data));	
		h = h->next;
    }
	return aux;
} // end sottolistaAnnoInListaR
nodeListR *sottolistaPrezzoInListaR(nodeListR * h, double a) {
	nodeListR *aux = NULL;
	while (h!=NULL) {
		if (h->data.prezzo == a) 
		  insertSortedListR(aux, createNodeR(h->data));	
		h = h->next;
    }
	return aux;
} // end sottolistaPrezzoInListaR

nodeListR *sottolistaTitoloCanzoneInListaR(nodeListR * h, char s[]) {
    int i;
	nodeListR *aux = NULL;
	while (h!=NULL) {
		i = 0; while ((i < h->data.num) && (strcmp(h->data.canzoni[i], s) != 0)) i++;
		if (i < h->data.num)
		  insertSortedListR(aux, createNodeR(h->data));	
		h = h->next;
    }
	return aux;

} // end sottolistaTitoloCanzoneInListaR

void coutAlbum(album a) {
     int i;

     cout << "\nCodice Album:   " << a.codiceR;
     cout << "\nNome Album:     " << a.nome;
     cout << "\nAnno Album:     " << setw(MAX_NUM_CHAR_IN_STRING) << a.anno;
     cout << "\nPrezzo Album:   " << setw(MAX_NUM_CHAR_IN_STRING) << a.prezzo;   
     cout << "\nNum Canzoni:    " << setw(MAX_NUM_CHAR_IN_STRING) << a.num;
	 for (i=0; i < a.num; i++) 
        cout << "\nTrack "<<i+1<<") " << a.canzoni[i];

     cout << "\n\n";cout.flush();
        

} // end printAlbum


void printListR(nodeListR* h) {
  cout << "\n";
  if (h != NULL) { 
    while (h!=NULL) { 
		coutAlbum(h->data);
		h = h->next; 
    }
    cout << "\n\n";
  }
  else cout << "Empty!";
} // end printListA

void eraseListR(nodeListR* &h) {
    int i;
    nodeListR * aux;
    while (h!= NULL) {
      aux = h;
      h = h->next;
      for (i=0; i < aux->data.num; i++) delete aux->data.canzoni[i];
      delete aux;
    }
} // end eraseListR




void Crea_ListaR_daFile(nodeListR*& alist) {
// Lista mantenuta ordinata alfabeticamente per codice_univoco_album

   ifstream fin;

   fin.open(NOME_FILE_ALBUM);
   if (fin.fail()) {
      cout << "Problemi in apertura del file ./FileAlbum.dat";
      system("PAUSE");
      exit(1);
   }

   char buffer[(6+MAX_CANZONI_IN_ALBUM)*(MAX_NUM_CHAR_IN_STRING+NUMCHARSEP)+1];
   int i,read;
   album sa;
   char buffaux[MAX_NUM_CHAR_IN_STRING+1];
   nodeListR *nodo_aux = NULL;
   nodeListR *head = NULL;

   fin.getline(buffer,(6+MAX_CANZONI_IN_ALBUM)*(MAX_NUM_CHAR_IN_STRING+NUMCHARSEP)+1,'\n');
   read = strlen(buffer);           
   while (!fin.fail() && read > 0) {

       strncpy(sa.codiceR,buffer,MAX_NUM_CHAR_IN_STRING);
       sa.codiceR[MAX_NUM_CHAR_IN_STRING] = '\0';

       strncpy(sa.nome,buffer+1*MAX_NUM_CHAR_IN_STRING+1*NUMCHARSEP,MAX_NUM_CHAR_IN_STRING);
       sa.nome[MAX_NUM_CHAR_IN_STRING] = '\0';

       strncpy(sa.codiceA,buffer+2*MAX_NUM_CHAR_IN_STRING+2*NUMCHARSEP,MAX_NUM_CHAR_IN_STRING);
       sa.codiceA[MAX_NUM_CHAR_IN_STRING] = '\0';

       strncpy(buffaux,buffer+3*MAX_NUM_CHAR_IN_STRING+3*NUMCHARSEP,MAX_NUM_CHAR_IN_STRING);
       buffaux[MAX_NUM_CHAR_IN_STRING] = '\0';
       sa.anno = atoi(buffaux);

       strncpy(buffaux,buffer+4*MAX_NUM_CHAR_IN_STRING+4*NUMCHARSEP,MAX_NUM_CHAR_IN_STRING);
       buffaux[MAX_NUM_CHAR_IN_STRING] = '\0';
       sa.prezzo = atof(buffaux);

       strncpy(buffaux,buffer+5*MAX_NUM_CHAR_IN_STRING+5*NUMCHARSEP,MAX_NUM_CHAR_IN_STRING);
       buffaux[MAX_NUM_CHAR_IN_STRING] = '\0';
       sa.num = atoi(buffaux);

       for (i=0; i < sa.num; i++) {
          strncpy(buffaux,buffer+(6+i)*MAX_NUM_CHAR_IN_STRING+(6+i)*NUMCHARSEP,MAX_NUM_CHAR_IN_STRING);
          buffaux[MAX_NUM_CHAR_IN_STRING] = '\0';
          sa.canzoni[i] = new char[MAX_NUM_CHAR_IN_STRING+1];
          strcpy(sa.canzoni[i],buffaux);
       }


       nodo_aux = createNodeR(sa);
       insertSortedListR(head,nodo_aux);
       
       fin.getline(buffer,(6+MAX_CANZONI_IN_ALBUM)*(MAX_NUM_CHAR_IN_STRING+NUMCHARSEP)+1,'\n');
       read = strlen(buffer);
   } // end while
   fin.close();

   alist = head;
   // Copia della testa nella lista nel parametro passato per
   // reference usato come valore di ritorno.

} // Crea_ListaA_daFile

void Scrivi_ListaR_suFile(nodeListR * & list) {

   ofstream fout;

   fout.open(NOME_FILE_ALBUM,ios::out); // Riscrivo l'intero File ad ogni salvataggio.
   if (fout.fail()) {
      cout << "Problemi in apertura del file C:/FileAlbum.dat";
      system("PAUSE");
      exit(1);
   }

   nodeListR *aux = list;
   int j;
   char buffaux[MAX_NUM_CHAR_IN_STRING+1];
   while (aux!=NULL) {
       
	   // Formatto una riga del file 
       // Nei nodi della lista tutti i campi stringa del record hanno gi lunghezza
       // di MAX_NUM_CHAR_IN_STRING caratteri
       fout << aux->data.codiceR; 
	   fout << setw(NUMCHARSEP) << SEPARATORE;

	   fout << aux->data.nome; 
	   fout << setw(NUMCHARSEP) << SEPARATORE;
       
	   fout << aux->data.codiceA; 
	   fout << setw(NUMCHARSEP) << SEPARATORE;

       sprintf(buffaux,"%4d",aux->data.anno);
	   fout << setw(MAX_NUM_CHAR_IN_STRING) << buffaux;
	   fout << setw(NUMCHARSEP) << SEPARATORE;

       sprintf(buffaux,"%7.2lf",aux->data.prezzo);
       fout << setw(MAX_NUM_CHAR_IN_STRING) << buffaux;
	   fout << setw(NUMCHARSEP) << SEPARATORE;

       sprintf(buffaux,"%2d",aux->data.num);
       fout << setw(MAX_NUM_CHAR_IN_STRING) << buffaux;
	   fout << setw(NUMCHARSEP) << SEPARATORE;


       for (j=0; j < aux->data.num-1; j++) {
          fout << aux->data.canzoni[j];
          fout << setw(NUMCHARSEP) << SEPARATORE;
       }
       fout << aux->data.canzoni[j];
       fout << '\n';

        // passo al nodo successivo
	   aux = aux->next;
   }
   fout.close();
   
} // Scrivi_ListaR_suFile






void Cin_insertNewAlbum(nodeListR* & AlbumList) {
   album sr;
   int c;
   int flag = 0; 
   do {
       cout << "\nNuovo codice album (max " << MAX_NUM_CHAR_IN_STRING << " caratteri): ";
       acquisisci_stringa(sr.codiceR);
       if (CercaCodiceRInListaR(AlbumList, sr.codiceR) != NULL) flag = 1;
       if (flag == 1) cout << "\nCODICE ALBUM GIA' PRESENTE IN ARCHIVIO\n";
   } while (flag == 1);
   cout << "\nNuovo nome album (max " << MAX_NUM_CHAR_IN_STRING << " caratteri): ";
   acquisisci_stringa(sr.nome);
   cout << "\nCodice artista (max " << MAX_NUM_CHAR_IN_STRING << " caratteri): ";
   acquisisci_stringa(sr.codiceA);
   cout << "\nAnno album: ";
   cin >> sr.anno; cin.ignore();
   cout << "\nPrezzo album: ";
   cin >> sr.prezzo; cin.ignore();
   do {
        cout << "\nNumero canzoni ( <= "<< MAX_CANZONI_IN_ALBUM <<" ): ";
        cin >> sr.num; cin.ignore(); 
   } while ((sr.num <= 0)||(sr.num > MAX_CANZONI_IN_ALBUM));
   for (c=0; c < sr.num; c++) {
      cout << "\nTitolo Canzone " << c+1 << " (max " << MAX_NUM_CHAR_IN_STRING << " caratteri): ";
      sr.canzoni[c] = new char[MAX_NUM_CHAR_IN_STRING+1];
      acquisisci_stringa(sr.canzoni[c]);
   }
   // Aggiornamento lista album
   insertSortedListR(AlbumList, createNodeR(sr));

} // end Cin_insertNewAlbum

















#endif
