#ifndef __ARTISTI_CPP_BODY_FILE__
#define __ARTISTI_CPP_BODY_FILE__

#include "Artisti.h"


nodeListA *createNodeA(artista sa) {

     nodeListA *p = new nodeListA;      // Creazione nuovo nodo
     p->data = sa;
     p->next = NULL;
	 return p;
}
 
nodeListA * CercaCodiceAInListaA(nodeListA * h, char codice[]) { 
// restituisce il puntatore al nodo contenente la prima occorrenza del codice preso come parametro.
	while ((h!=NULL)&&(strcmp(h->data.codice,codice)!=0)) h = h->next;
	return h;
} // end CercaCodiceAInListaA
nodeListA *sottolistaCodiceAInListaA(nodeListA * h, char s[]) {
	nodeListA *aux = NULL;
	while (h!=NULL) {
		if (strcmp(h->data.codice,s) ==0) 
		  insertSortedListA(aux, createNodeA(h->data));	
		h = h->next;
    }
	return aux;
} // end sottolistaCodiceAInListaA
nodeListA *sottolistaNomeAInListaA(nodeListA * h, char s[]) {
	nodeListA *aux = NULL;
	while (h!=NULL) {
		if (strcmp(h->data.nome,s) ==0) 
		  insertSortedListA(aux, createNodeA(h->data));	
		h = h->next;
    }
	return aux;
} // end sottolistaNomeAInListaA
nodeListA *sottolistaCognomeAInListaA(nodeListA * h, char s[]) {
	nodeListA *aux = NULL;
	while (h!=NULL) {
		if (strcmp(h->data.cognome,s) ==0) 
		  insertSortedListA(aux, createNodeA(h->data));	
		h = h->next;
    }
	return aux;
} // end sottolistaCognomeAInListaA
nodeListA *SottolistaCompensoAInListaA(nodeListA * h, double a) {
	nodeListA *aux = NULL;
	while (h!=NULL) {
		if (h->data.compenso == a) 
		  insertSortedListA(aux, createNodeA(h->data));	
		h = h->next;
    }
	return aux;
} // end sottolistaCompensoAInListaA


void insertSortedListA(nodeListA* & h, nodeListA *x) {
// Si suppone la lista in ordine alfabetico di codice
// si inserisce un nuovo nodo rispettando tale ordinamento        
// h  passato per reference, per scandire 
// la lista devo quindi usare un puntatore ausiliario.

    nodeListA *curr;
    nodeListA *pred = NULL;

    if (h == NULL) { h = x;
	                 return;
    }
    curr = h ;
    while ((curr!=NULL)&&(strcmp((curr->data).codice,(x->data).codice)<= 0)){
         pred = curr;
         curr = curr->next ;
    }

    if (pred != NULL) {
	  pred->next = x;
      x->next = curr;
    } else {            // inserimento in testa
	   x->next = h;
	   h = x;
    }
} // end insertSortedListA


void coutArtista(artista a) {
	    
        cout << "\nCodice Artista:   " << a.codice;
        cout << "\nNome Artista:     " << a.nome;
		cout << "\nCognome Artista:  " << a.cognome;
        cout << "\nCompenso Artista: " << setw(MAX_NUM_CHAR_IN_STRING) << a.compenso;
		cout << "\n\n";cout.flush();
} // end coutArtista

void printListA(nodeListA* h) {
  cout << "\n";
  if (h != NULL) { 
    while (h!=NULL) { 
        coutArtista(h->data);
        h = h->next; 
    }
    cout << "\n\n";
  }
  else cout << "Empty!";
} // end printListA

void eraseListA(nodeListA* &h) {
    nodeListA * aux;
    while (h!= NULL) {
      aux = h;
      h = h->next;
      delete aux;
    }
} // end eraseListA












void Crea_ListaA_daFile(nodeListA*& list) {
// Lista mantenuta ordinata alfabeticamente per codice_univoco_album

   ifstream fin;
   fin.open(NOME_FILE_ARTISTI);
   if (fin.fail()) {
      cout << "Problemi in apertura del file ./FileArtisti.dat ";
      system("PAUSE");
      exit(1);
   }

   char buffer[4*(MAX_NUM_CHAR_IN_STRING+NUMCHARSEP)+1]; // ci sono 4 campi per rigo nel file
   int read;
   artista sa;
   char buffaux[MAX_NUM_CHAR_IN_STRING+1];
   nodeListA *nodo_aux = NULL;
   nodeListA *head = NULL;

   fin.getline(buffer,4*(MAX_NUM_CHAR_IN_STRING+NUMCHARSEP)+1,'\n');
   read = strlen(buffer);           
   while (!fin.fail() && read > 0) {

       strncpy(sa.codice,buffer,MAX_NUM_CHAR_IN_STRING);
       sa.codice[MAX_NUM_CHAR_IN_STRING] = '\0';

       strncpy(sa.nome,buffer+1*MAX_NUM_CHAR_IN_STRING+NUMCHARSEP,MAX_NUM_CHAR_IN_STRING);
       sa.nome[MAX_NUM_CHAR_IN_STRING] = '\0';

       strncpy(sa.cognome,buffer+2*MAX_NUM_CHAR_IN_STRING+2*NUMCHARSEP,MAX_NUM_CHAR_IN_STRING);
       sa.cognome[MAX_NUM_CHAR_IN_STRING] = '\0';

       strncpy(buffaux,buffer+3*MAX_NUM_CHAR_IN_STRING+3*NUMCHARSEP,MAX_NUM_CHAR_IN_STRING);
       buffaux[MAX_NUM_CHAR_IN_STRING] = '\0';
       sa.compenso = atof(buffaux);

       nodo_aux = createNodeA(sa);
       insertSortedListA(head,nodo_aux);
       

       fin.getline(buffer,4*(MAX_NUM_CHAR_IN_STRING+NUMCHARSEP)+1,'\n');
       read = strlen(buffer);
   } // end while
   fin.close();

   list = head;
   // Copia della testa nella lista nel parametro passato per
   // reference usato come valore di ritorno.

} // Crea_ListaA_daFile

void Scrivi_ListaA_suFile(nodeListA*& list) {

   ofstream fout;

   fout.open(NOME_FILE_ARTISTI,ios::out); // Riscrivo l'intero File ad ogni salvataggio.
   if (fout.fail()) {
      cout << "Problemi in apertura del file ./FileArtisti.dat";
      system("PAUSE");
      exit(1);
   }

   nodeListA *aux = list;
   
   char buffaux[MAX_NUM_CHAR_IN_STRING+1];
   while (aux!=NULL) {
       
	   // Formatto una riga del file 
       // Nei nodi della lista tutti i campi stringa del record hanno gi lunghezza
       // di MAX_NUM_CHAR_IN_STRING caratteri
	   fout << aux->data.codice;  
	   fout << setw(NUMCHARSEP) << SEPARATORE;
       
	   fout << aux->data.nome;    
	   fout << setw(NUMCHARSEP) << SEPARATORE;
       
	   fout << aux->data.cognome; 
	   fout << setw(NUMCHARSEP) << SEPARATORE;

       sprintf(buffaux,"%7.2lf",aux->data.compenso);
	   fout << setw(MAX_NUM_CHAR_IN_STRING) << buffaux << '\n';

        // passo al nodo successivo
	   aux = aux->next;
   }
   fout.close();
   
} // Scrivi_ListaA_suFile



// Inserisci Nuovo Artista
void Cin_insertNewArtist(nodeListA* & ArtistList) {
   artista sa; 
   int flag = 0;
   do {
       cout << "\nNuovo codice artista (max " << MAX_NUM_CHAR_IN_STRING << " caratteri): ";
       acquisisci_stringa(sa.codice);
       if (CercaCodiceAInListaA(ArtistList, sa.codice) != NULL) flag = 1;
       if (flag == 1) cout << "\nCODICE ARTISTA GIA' PRESENTE IN ARCHIVIO\n";
   } while (flag == 1);
   cout << "\nNuovo nome artista (max " << MAX_NUM_CHAR_IN_STRING << " caratteri): ";
   acquisisci_stringa(sa.nome);
   cout << "\nNuovo cognome artista (max " << MAX_NUM_CHAR_IN_STRING << " caratteri): ";
   acquisisci_stringa(sa.cognome);
   cout << "Compenso artista: ";
   cin >> sa.compenso; cin.ignore();

    // Aggiornamento lista Artisti
   insertSortedListA(ArtistList, createNodeA(sa));

} // end Cin_insertNewArtist

#endif
