/*******************************************************************************
ESERCIZIO 3
Si realizzi un programma che una casa discografica pu utilizzare per
gestire gli album musicali degli artisti.
	Il programma deve gestire i dati degli artisti, quindi consente di inserire
    i dati degli album, dove ogni album  un insieme di canzoni.
	Per ogni album si vuole avere l'anno di uscita e il prezzo.
	Il programma deve consentire di consultare l'elenco degli album in base a
    diversi criteri di ricerca (per artista, per anno, per titolo,
    per canzone contenuta).
Si realizzi il programma in modo che possa gestire un numero arbitrariamente
ampio di artisti e di album.

Interpretazione della traccia -- Ipotesi di lavoro semplificate:

1.	Gli artisti sono associati solo agli Album.
    Ciascun Album pu avere un solo Artista autore dello stesso.
2.	Le canzoni sono associate solo agli Album.

In pratica un Artista pu essere autore di pi Album ma le canzoni sono
specifiche di ciascun Album. 

Gestiamo il problema con una coppia di archivi separati: quello degli Artisti e
quello degli Album, perch sono archivi che possono essere interessati
separatamente (ma anche congiuntamente) da operazioni di aggiornamento o
pi in generale di manipolazione delle informazioni in esso contenute.

File Artisti: 
Contiene i record relativi ad ogni artista le cui canzoni sono
commercializzate dalla casa discografica. 

Ogni artista  identificato da un suo codice univoco.  
Il singolo record contiene:
	codice_artista 
	Nome artista 
	Compenso Artista

File Album: 
Contiene i record relativi ad ogni album prodotto dalla casa discografica.
Il singolo record contiene:
    
-	Codice Album
-	Nome dell'album 
-	Codice Artista
-	Anno di uscita 
-	Prezzo
-	Numero di canzoni contenute (scelta di progetto:... MAX 40)
-	Titoli delle canzoni contenute nell'album.


  
Il programma preveder due moduli:
Artisti.h, Artisti.cpp 
per implementare tutti i sottoprogrammi utili alla gestione degli Artisti e
le routine per la creazione di una lista dinamica contenente in ogni nodo
i successivi record nel file.

Album.h, Album.cpp 
per implementare tutti i sottoprogrammi utili alla gestione degli Album e
le routine per la creazione di una lista dinamica contenente in ogni nodo
i successivi record nel file.

CasaDiscografica.cpp
Per implementare i men interattivi di interfaccia con l'utente e i
sottoprogrammi che usano i tipi di dato astratto e i moduli precedenti
per rispondere alle specifiche del problema.

*/
#include <iostream.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <fstream.h>
#include "Artisti.h"
#include "Album.h"
#include "Const_and_Utility.h"


void Cout_Elenca_per_Nome_Artista(nodeListA * ArtistList, nodeListR * AlbumList);
void Cout_Elenca_per_Titolo_Album(nodeListA * ArtistList, nodeListR * AlbumList);
void Cout_Elenca_per_Anno_Album(nodeListA * ArtistList, nodeListR * AlbumList);
void Cout_Elenca_per_Titolo_Canzone(nodeListA * ArtistList, nodeListR * AlbumList);
void Cout_Elenca_Tutto(nodeListA * ArtistList, nodeListR * AlbumList);

int main(void) {

  int choice;
  int choice1, choice1_1, choice1_2, choice1_3;
  int choice2;

  nodeListA * ArtistList = NULL;
  nodeListR * AlbumList  = NULL;

  Crea_ListaA_daFile(ArtistList);
  Crea_ListaR_daFile(AlbumList);
  
  do {
       choice = main_menu();
  
       switch (choice) {

          case 1 : do { // Aggiorna Archivio
			           choice1 = update_menu();
			           switch (choice1) {
                         
					      case 1 : // Inserimento
                                   do {
			                          choice1_1 = insert_menu();
			                          switch (choice1_1) {
                         
					                     case 1 : // Inserisci nuovo artista
                                                  Cin_insertNewArtist(ArtistList);
												  press_key();
							                      break ;
						                 case 2 : // Inserisci Nuovo Album
                                                  Cin_insertNewAlbum(AlbumList);   
						   		                  press_key();
							                      break ;

                                         default: 
											      break ; 
									  } // end switch choice1_1
								  } while (choice1_1 != 3);

                			      break;

						  case 2: // Modifica
                                  do {
			                          choice1_2 = modify_menu();
			                          switch (choice1_2) {
                         
					                     case 1 : // Modifica Nome Artista
											      press_key();
							                      break ;
						                 case 2 : // Modifica Anno Album
						   		                  press_key();
							                      break ;
 						                 case 3 : // Modifica Titolo Album
				       	                          press_key();
							                      break ;
		   				                 case 4 : // Modifica Titolo Canzone
				       	                          press_key();
							                      break ;
						                 case 5 : // Modifica Prezzo Album
				       	                          press_key();
							                      break ;
                                         default: 
											      break ; 
									  } // end switch choice1_2
								  } while (choice1_2 != 6);

                			      break;

						  case 3 : // Cancellazione

                                  do { 
			                            choice1_3 = erase_menu();
			                            switch (choice1_3) {
                         
					                       case 1 : // Cancella Artista
                                                    press_key();
							                        break ;
						                   case 2 : // Cancella Album 
						   		                    press_key();
							                        break ;
 						                   case 3 : // Cancella Canzone
				       	                            press_key();
							                        break ;

                                          default : 
											        break ; 
										} // end switch choice1_3
								  } while (choice1_3 != 4);

				       	          break ;
						  
                          default: 
							      break ; 
					   } // end switch choice1
				   } while (choice1 != 4);

			       break ;

		  case 2 : do { // Consulta Elenco Album
			           choice2 = lookUp_menu(); 
			           switch (choice2) {
                         
					      case 1 : // Cerca per Nome Artista
							       Cout_Elenca_per_Nome_Artista(ArtistList,AlbumList);
                                   press_key();
							       break ;
						  case 2 : // Cerca per Anno
                                   Cout_Elenca_per_Anno_Album(ArtistList,AlbumList);
						   		   press_key();
							       break ;
 						  case 3 : // Cerca per Titolo Album
							       Cout_Elenca_per_Titolo_Album(ArtistList,AlbumList);
				       	           press_key();
							       break ;
						  case 4 : // Cerca per Titolo Canzone
                                   Cout_Elenca_per_Titolo_Canzone(ArtistList,AlbumList);
                                   press_key();
							       break ;
						  case 5 : // Elenca Tutti i Contenuti
							       Cout_Elenca_Tutto(ArtistList,AlbumList);
						   		   press_key();
							       break ;

                          default: 
							       break ; 
					   } // end switch choice2
				   } while (choice2 != 6);

                   break ;
                   
		  default: 
			       break ; 
	   } // end switch 
  } while (choice != 3);

  closing_message();
  press_key();

  Scrivi_ListaR_suFile(AlbumList);
  Scrivi_ListaA_suFile(ArtistList);

  return 0;
}  // end main

void Cout_Elenca_per_Nome_Artista(nodeListA * ArtistList, nodeListR * AlbumList) {
// N.B.: Le due Liste sono ordinate per codiceArtista e CodiceAlbum rispettivamente
    
	char buff[MAX_NUM_CHAR_IN_STRING+1];
	nodeListA* auxA = NULL;
    nodeListR* auxR = NULL;

	cout << "\nnome artista: ";
	acquisisci_stringa(buff);
    
	auxA = sottolistaNomeAInListaA(ArtistList,buff); //ordinata per codice artista (univoco)
    while (auxA!=NULL) {

		cout << "\n-----------------------------------------------------------";        
        coutArtista(auxA->data);
		
		auxR = sottolistaCodiceAInListaR(AlbumList,auxA->data.codice); // ordinata per codice album (univoco)
		while (auxR!=NULL) {
          coutAlbum(auxR->data);
          auxR = auxR->next;  
		}

        auxA = auxA->next;
	}
	eraseListA(auxA);
    eraseListR(auxR);

} // end Cout_Elenca_per_Nome_Artista


void Cout_Elenca_per_Titolo_Album(nodeListA * ArtistList, nodeListR * AlbumList) {
// N.B.: Le due Liste sono ordinate per codiceArtista e CodiceAlbum rispettivamente
    
	char buff[MAX_NUM_CHAR_IN_STRING+1];
	nodeListA* auxA = NULL;
    nodeListR* auxR = NULL;

	cout << "\ntitolo album: ";
	acquisisci_stringa(buff);
    
	auxR = sottolistaNomeInListaR(AlbumList,buff); //ordinata per codice album (univoco)
    while (auxR!=NULL) {
		
        cout << "\n-----------------------------------------------------------";        
		coutAlbum(auxR->data);
		
		auxA = sottolistaCodiceAInListaA(ArtistList,auxR->data.codiceA); // ordinata per codice artista (univoco)--> 1 solo nodo
		while (auxA!=NULL) {
          coutArtista(auxA->data);
          auxA = auxA->next;  
		}

        auxR = auxR->next;
	}
	eraseListA(auxA);
    eraseListR(auxR);

} // end Cout_Elenca_per_Nome_Artista


void Cout_Elenca_per_Anno_Album(nodeListA * ArtistList, nodeListR * AlbumList) {
// N.B.: Le due Liste sono ordinate per codiceArtista e CodiceAlbum rispettivamente
    
	int aa;
	nodeListA* auxA = NULL;
    nodeListR* auxR = NULL;
    
	cout << "\nanno album: ";
	cin >> aa;cin.ignore();
    
	auxR = sottolistaAnnoInListaR(AlbumList,aa); //ordinata per codice album (univoco)
    while (auxR!=NULL) {
		
        cout << "\n-----------------------------------------------------------";        
		coutAlbum(auxR->data);
		
		auxA = sottolistaCodiceAInListaA(ArtistList,auxR->data.codiceA); // ordinata per codice artista (univoco)--> 1 solo nodo
		while (auxA!=NULL) {
          coutArtista(auxA->data);
          auxA = auxA->next;  
		}

        auxR = auxR->next;
	}
	eraseListA(auxA);
    eraseListR(auxR);

} // end Cout_Elenca_per_Anno_Artista

void Cout_Elenca_per_Titolo_Canzone(nodeListA * ArtistList, nodeListR * AlbumList) {
// N.B.: Le due Liste sono ordinate per codiceArtista e CodiceAlbum rispettivamente
    
	char buff[MAX_NUM_CHAR_IN_STRING+1];
	nodeListA* auxA = NULL;
    nodeListR* auxR = NULL;

	cout << "\ntitolo canzone: ";
	acquisisci_stringa(buff);
    
	auxR = sottolistaTitoloCanzoneInListaR(AlbumList,buff); //ordinata per codice album (univoco)
    while (auxR!=NULL) {
		
        cout << "\n-----------------------------------------------------------";        
		coutAlbum(auxR->data);
		
		auxA = sottolistaCodiceAInListaA(ArtistList,auxR->data.codiceA); // ordinata per codice artista (univoco)--> 1 solo nodo
		while (auxA!=NULL) {
          coutArtista(auxA->data);
          auxA = auxA->next;  
		}

        auxR = auxR->next;
	}
	eraseListA(auxA);
    eraseListR(auxR);

} // end Cout_Elenca_per_Titolo_Canzone

void Cout_Elenca_Tutto(nodeListA * ArtistList, nodeListR * AlbumList) {
// N.B.: Le due Liste sono ordinate per codiceArtista e CodiceAlbum rispettivamente
    
	char buff[MAX_NUM_CHAR_IN_STRING+1];
	nodeListA* auxA = NULL;
    nodeListR* auxR = NULL;

	auxR = AlbumList;
    while (auxR!=NULL) {
		
        cout << "\n-----------------------------------------------------------";        
		coutAlbum(auxR->data);
		strcpy(buff,auxR->data.codiceR);
		
		auxA = sottolistaCodiceAInListaA(ArtistList,auxR->data.codiceA); // ordinata per codice artista (univoco)--> 1 solo nodo
		while (auxA!=NULL) {
          coutArtista(auxA->data);
          auxA = auxA->next;  
		}

        do { auxR = auxR->next;} while ((auxR!=NULL) && strcmp(auxR->data.codiceR,buff)==0);
	}
	eraseListA(auxA);


} // end Cout_Elenca_Tutto
